/*** inflatorpngηҤ, ByteWriter */

#include "sszl.h"
#include "png.h"
#include "byteWriter.h"

void ByteWriter_init(ByteWriter_t this, Png_t png)
{
  this->pos = 0;
  this->total = 0;
  this->adler = 1;
  this->png = png;
}

int ByteWriter_putByte(ByteWriter_t this, byte x)
{
  this->top[this->pos++] = x;
  this->total++;
  this->pos &= RINGMASK;
  Png_putByte(this->png, x);
  this->adler = update_adler32(this->adler, &x, 1);
  return SZL_OK;
}

int ByteWriter_copyDistance(ByteWriter_t this, int len, int dist)
{
  int ret;

  if (this->total < dist || RINGMASK < dist) {
    ret = SZL_DATA_ERROR;
  } else {
    int from = (this->pos - dist) & RINGMASK;
    while (len > 0) {
      /* Ϣ³ƥԡǤĹ, ԡ */
      int l = len;		/* Υ롼פǥԡĹ */
      int pmax = this->pos < from ? from : this->pos;
      int pos = this->pos, i;
      if (pmax + l - 1 > RINGMASK)
	l = RINGMASK + 1 - pmax;
      for (i = l; i > 0; i--)
	this->top[pos++] = this->top[from++];
      this->adler = update_adler32(this->adler, &this->top[this->pos], l);
      Png_putByteString(this->png, &this->top[this->pos], l);
      this->total += l;
      this->pos = pos & RINGMASK;
      from &= RINGMASK;
      len -= l;
    }
    ret = SZL_OK;
  }
  return ret;
}

uint ByteWriter_getTotalOut(ByteWriter_t this)
{
  return this->total;
}

uint ByteWriter_getAdler32(ByteWriter_t this)
{
  return this->adler;
}
