#ifndef _PNG_H_INCLUDED_
#define _PNG_H_INCLUDED_

/** s덷gU[` */
typedef void (*Gosakaku_t)(int,int*,int,int*,char*);

/** png錾 */
typedef struct Png *Png_t;

#include "sszl.h"
#include "byteWriter.h"
#include "bitReader.h"

int Png_parse(Png_t png, byte **fpp, byte *end);
uint Png_getRequiredSize(Png_t png);
int Png_memallocate(Png_t png, byte *lower, uint size, byte *image, Gosakaku_t gosakaku);
byte *Png_getNextIdat(Png_t png, int *size);
int Png_decode(Png_t png, int skip);
void Png_putByte(Png_t png, byte x);
void Png_putByteString(Png_t png, byte *p, int len);
uint Png_getWidth(Png_t png);
uint Png_getHeight(Png_t png);

enum PNG_ERROR {
  ERROR_CRC = 1,
  ERROR_SIGNATURE,
  ERROR_COMPRESS,
  ERROR_FILTER,
  ERROR_INTERLACE,
  ERROR_INVALIDINTERLACE,
  ERROR_PALETTE,
  ERROR_DATA,
  ERROR_COLORTYPE,
  ERROR_DEPTH,
  ERROR_END,
};

enum COLORTYPE_INFO {
	NONE_USED      = 0,
	PALETTE_USED   = 1,
	TRUECOLOR_USED = 2,
	ALPHA_USED    = 4,
};

enum COLORTYPE {
	GRAYSCALE            = NONE_USED,
	TRUECOLOR            = TRUECOLOR_USED,
	INDEXCOLOR           = PALETTE_USED   | TRUECOLOR_USED,
	GRAYSCALE_WITH_ALPHA = NONE_USED      | ALPHA_USED,
	TRUECOLOR_WITH_ALPHA = TRUECOLOR_USED | ALPHA_USED,
};


/** g̐錾 */
typedef struct Color{
  byte r, g, b;
} Color, *Color_t;

typedef struct Png {		/* ϒ̂̂Ƒ傫̂̓|C^ */
  Inflator_t inf;
  ByteWriter_t buf;		/* inflatȅo̓obt@ */
  BitReader_t stream;		/* inflate̓̓rbgXg[ */
  byte *idat;			/* ߈ȍ~IDAT`N */
  Color plte[256];		/* pbg */
  uint width, height, scan_width, zlen, dlen, imglen;
  byte *zfmt;
  byte *prev, *line, *true, *image; /* Os, s, 32bpps, o͐ */
  int x, y;			/* ݏݒ̍W */
  byte bit_depth, clr_type, bpp; /* bit per pixel */
  byte filterMode, interlace, pass;
  Gosakaku_t gosakaku;
  int lineLength;		/* o͍s̒(oCgP) */
} Png;

#endif /* _PNG_H_INCLUDED_ */
