#ifndef _SSZL_H_INCLUDED_
#define _SSZL_H_INCLUDED_
typedef unsigned char byte;
typedef unsigned int uint;

/** BitReader錾 */
typedef struct BitReader *BitReader_t;
int BitReader_getBits(BitReader_t this, int len, int *x);
int BitReader_peekBits(BitReader_t this, int len, int *x);
int BitReader_getByte(BitReader_t this, int *x);
uint BitReader_getTotal(BitReader_t this);

/** ByteWriter錾 */
typedef struct ByteWriter *ByteWriter_t;
int ByteWriter_putByte(ByteWriter_t this, byte x);
int ByteWriter_copyDistance(ByteWriter_t this, int len, int dist);
uint ByteWriter_getTotalOut(ByteWriter_t this);
uint ByteWriter_getAdler32(ByteWriter_t this);

/** CRC32錾 */
typedef struct CRC32 *CRC32_t;
void CRC32_init(CRC32_t this);
uint CRC32_update(CRC32_t this, uint crc, byte *buf, uint len);

/** Inflator錾 */
typedef struct Inflator *Inflator_t;
uint update_adler32(uint adler, byte *buf, uint len);
int decomp_zlib(Inflator_t inf);
void init_inflate(Inflator_t inf, BitReader_t bin, ByteWriter_t bout);
uint get_total_in(Inflator_t inf);
uint get_total_out(Inflator_t inf);
int decomp_dfmt(Inflator_t inf);
#define SZL_OK           0
#define SZL_BUF_ERROR   -1
#define SZL_MEM_ERROR   -2
#define SZL_DATA_ERROR  -3
#define SZL_IMPLIMENT_ERROR -4


/** g̐錾 */
typedef struct CRC32 {
  uint table[256];	    /* Table of CRCs of all 8-bit messages. */
} CRC32;

typedef struct Tree {
  int max_sym;
  int max_blen;
  int len[288];
  int code[288];
  int bl_count[16];
  int next_code[16];
} Tree, *Tree_t;

typedef struct Inflator {
  BitReader_t bin;
  ByteWriter_t bout;
  Tree ctree[1];
  Tree ltree[1];
  Tree dtree[1];
  int btype;
  int bfinal;
  int oder[19];			/* e[ustatic\ */
  int len_tbl[29][2];
  int dist_tbl[30][2];
} Inflator;
#endif /* _SSZL_H_INCLUDED_ */
